import { assetManager, instantiate, Prefab, Node, UITransform, Vec3, Vec2, view, game, PhysicsSystem, geometry } from "cc";
import { ResLoader, resLoader } from "db://assets/core_tgx/base/ResLoader";
import { StormSunderGlobalInstance } from "../StormSunderGlobalInstance";
import { TornadoComponent } from "../Component/TornadoComponent";
import { TornadoAIComponent } from "../Component/TornadoAIComponent";

const res = [
    "Prefabs/Tornado",
]

/** 龙卷风管理器*/
export class PlayerMgr {
    private static _instance: PlayerMgr;
    public static get Instance(): PlayerMgr {
        if (this._instance == null) {
            this._instance = new PlayerMgr();
        }
        return this._instance;
    }

    public static get inst(): PlayerMgr {
        return this.Instance;
    }

    public tornadoNode: Node = null;//玩家节点

    //创建AI玩家
    public async genareatorAIPlayer(): Promise<void> {
        return new Promise(async (resolve, reject) => {
            const aiCount: number = 1;
            const aiPoints = StormSunderGlobalInstance.instance.aiPoints;
            for (let i = 0; i < aiCount; i++) {
                const infoPrefab = await resLoader.loadAsync(resLoader.gameBundleName, res[0], Prefab);
                let infoNode = instantiate(infoPrefab);
                infoNode.parent = StormSunderGlobalInstance.instance.players;

                const point = aiPoints.children[Math.floor(Math.random() * aiPoints.children.length)];
                infoNode.setPosition(point.worldPosition.clone());
                infoNode.addComponent(TornadoAIComponent);
                resolve();
            }
        })
    }

    //获取玩家龙卷风节点
    async getTornadoNode(): Promise<Node> {
        return new Promise((resolve, reject) => {
            if (this.tornadoNode) {
                resolve(this.tornadoNode);
            } else {
                const playersUI = StormSunderGlobalInstance.instance.players!;
                if (playersUI && playersUI.children.length > 0)
                    this.tornadoNode = playersUI.children[0];

                resolve(this.tornadoNode);
            }
        })
    }

    async playerAddComponent(): Promise<void> {
        return new Promise((resolve, reject) => {
            this.getTornadoNode().then(node => {
                node.addComponent(TornadoComponent)!;
                resolve();
            })
        })
    }
}

